#include <string>
#include <iostream>
#include <fstream>
#include <strstream>
#include <stdio.h>
#include <strings.h>
#ifndef AUDIOFILE_H
#define AUDIOFILE_H
#include "AudioFile.h"
#endif

using namespace std;

AudioFile::AudioFile(char* dateiname)
{
  this->readHeader.magic_number = 0;
  this->readHeader.header_size = 0;
  this->readHeader.data_length = 0;
  this->readHeader.encoding = 0;
  this->readHeader.sample_rate = 0;
  this->readHeader.nr_of_channels = 0;
  this->readDataOrg.dataOrg = NULL;
  this->readDataOrg.dataOrgD = NULL;
  mn = false;
  hs = false;
  dl = false;
  en = false;
  sr = false;
  noc = false;
  ahb = false;
  zd = false;
  filename=dateiname;
}

AudioFile::~AudioFile()
{
  //cout << "my vocal was: " << this->addHeader.additional[0] << endl;
    free( (signed char *)this->readDataOrg.dataOrg );
    free( (double *)this->readDataOrg.dataOrgD );
}

char AudioFile::getVocal()
{
  //cout << "my vocal was: " <<  this->addHeader.additional[0] << endl;
  return this->addHeader.additional[0];
}

long AudioFile::getDataLength()
{
  return (long)this->readHeader.data_length;
}

double* AudioFile::getDataOriginal()
{
  if (this->readDataOrg.dataOrgD == NULL)
    {
      this->readDataOrg.dataOrgD = (double *)calloc(this->readHeader.data_length, sizeof(double));
      
      for (int i=0;i<this->readHeader.data_length;i++)
	{
	  this->readDataOrg.dataOrgD[i] = (double)this->readDataOrg.dataOrg[i];
	}
    }
  return this->readDataOrg.dataOrgD;
}

int AudioFile::readData()
{
    fstream in(this->filename, ios::in | ios::binary);
    in.read( (char *)&(this->readHeader), sizeof(struct Header));
    in.read(&(this->addHeader.additional), (this->readHeader.header_size)-(0x18) );
    this->readDataOrg.dataOrg = (signed char*)calloc(this->readHeader.data_length, sizeof (signed char));
    in.read(this->readDataOrg.dataOrg, this->readHeader.data_length);
    in.close();
    return this->verify();
}

void AudioFile::text()
{
  if (mn == true)
    {
      cout << hex << "#MagicNumber: " << this->readHeader.magic_number << endl;
    }
  else
    {
      cout << "#MagicNumber ERROR!" << endl;
      return;
    }
  if (hs == true)
    {
      cout << hex << "#Headersize: " << this->readHeader.header_size << endl;
    }
  else
    {
      cout << "#Headersize ERROR!" << endl; 
      return;
    }
  if (dl == true)
    {
      cout << hex << "#Datalength: " << this->readHeader.data_length << endl;
    }
  else
    {
      cout << "#Datalength ERROR!" << endl; 
      return;
    }
  if (en == true)
    {
      cout << hex << "#Encoding: " << this->readHeader.encoding << endl;
    }
  else
    {
      cout << "#Encoding ERROR!" << endl; 
      return;
    }
  if (sr == true)
    {
      cout << hex << "#Samplerate: " << this->readHeader.sample_rate << endl;
    }
  else
    {
      cout << "#Samplerate ERROR!" << endl; 
      return;
    }
  if (noc == true)
    {
      cout << hex << "#Nr of Channels: " << this->readHeader.nr_of_channels << endl;
    }
  else
    {
      cout << "#Nr of Channels ERROR!" << endl; 
      return;
    }
  if (ahb == true)
    {
      cout << hex << "#additional header byte(s): " << this->addHeader.additional << endl; 
    }
  else
    {
      cout << "#additional header bytes ERROR! " << endl; 
      return;
    }
  if (zd == true)
    {
      cout << hex << "#Zeitdauer ca: " << this->readHeader.data_length / this->readHeader.sample_rate << " sek." << endl;
    }
  else
    {
      cout << "#Zeitdauer ERROR!" << endl; 
      return;
    }
  cout << "#Dataoriginal: " << endl;
  for (int i=0;i<this->readHeader.data_length;i++)
    {	
      cout << dec << i << " " << ((double)this->readDataOrg.dataOrg[i]) << endl; 
    }
  cout << endl;
}

int AudioFile::verify()
{
  if ((this->readHeader.magic_number == 0x2E736E64) || (this->readHeader.magic_number == 0x2E736400))
    {
      mn = true;
    }
  else
    {
      return -1;
    }
  if (this->readHeader.header_size >= 0x18)
    {
      hs = true;
    }
  else
    {
      return -1;
    }
  if (this->readHeader.data_length > 0)
    {
      dl = true;
    }
  else
    {
      return -1;
    }
  if (this->readHeader.encoding == 1)
    {
      en = true;
    }
  else
    {
      return -1;
    }
  if (this->readHeader.sample_rate == 11025)
    {
      sr = true;
    }
  else
    {
      return -1;
    }
  if (this->readHeader.nr_of_channels == 1)
    {
      noc = true;
    }
  else
    {
      return -1;
    }
  
  if ((this->addHeader.additional[0] == 'a') || (this->addHeader.additional[0] == 'e') || (this->addHeader.additional[0] == 'i')
      || (this->addHeader.additional[0] == 'o') || (this->addHeader.additional[0] == 'u'))
    {
      ahb = true;
    }
  else
    {
      return -1;
    }
  if ((this->readHeader.data_length/this->readHeader.sample_rate) >= 3)
    {
      zd = true;
    }
  else
    {
      return -1;
    }
  return 0;
}

void AudioFile::play(int vol)
{
  ostrstream command;

  command << "audioplay " << "-v " << vol << " ";

  command << filename << ends;

  char *commandstr = command.str();

  delete &command;

  system(commandstr);  
}

// falls schon eine Datei mit diesem Namen existiert, wird sie ueberschrieben
int AudioFile::create(char vokal, float length, int vol)
{
  ostrstream command;

  //char *point;

  //char lengthstr[4];

  // wir muessen noch den Punkt in der Zeit
  // durch ein Komma ersetzen (muss man jetzt scheinbar nicht mehr, jetzt scheinbar doch wieder, oder doch nicht ?)
  // also nach der 10. Aenderung ist das nicht mehr lustig :-|
  //sprintf(lengthstr,"%.2f",length);

  //point = strstr(lengthstr, ".");

  //*point=(char)',';

  command << "audiorecord ";
  
  //----------------- ?? folgendes ntig ??
  
  //Volume
  command << "-v " << vol;

  //Channels
  command << " -c 1 ";

  //----------------- ??

  //Samplerate
  command << "-s 11025 ";

  //Encoding
  command << "-e ulaw ";

  //Laenge (wenn Punkt ersetzen, dann hier lengthstr statt length)
  command << "-t " << length << " ";

  //Info
  command << "-i " << vokal << " ";

  //File
  command << filename;

  // endl schliesst ostrstream ab
  command << ends;

  // Debug
  cout << command.str() << endl;

  //Commandline ausfhren...
  system(command.str());

  return 0;

}
