#include "AudioSignals.h"

#include <qcolor.h>
#include <qpainter.h>
#include <qpaintdevice.h>
#include <iostream.h>

AudioSignals::AudioSignals(QWidget *par=0, double *arr=0, long arrlength=0, int flag=1) : QWidget(par)
{
  setBackgroundColor(white);

  arrayOfData = arr;

  data_length = arrlength;
    
  Flag = flag;
}
 

void AudioSignals::paintEvent(QPaintEvent * qp)
{
  qp = 0;

  if(arrayOfData && data_length){

    double xscale=((double) width()-5)/(double) data_length;
   
    QPainter p(this);
   
    p.setPen(QPen(black,1,QPen::SolidLine));

    // 8192 Sample
    if (Flag == 1){

      for(int i=0;i<data_length;i+=1)
	p.drawLine(xscale*(double)(i),115,xscale*(double)(i),115-arrayOfData[i]);

    }

    // nach FFT
    else if (Flag == 2){

      // Maximalwert FFT Annahme 10 Million
      double yscale = (double)((double)height()/(double)1000000);

      for(int i=0;i<data_length;i+=1)
	p.drawLine(xscale*(double)(i),115,xscale*(double)(i),115-(yscale*arrayOfData[i]));

    }

    // nach Fensterung
    else {

      for(int i=0;i<data_length;i+=1)
	p.fillRect(i*15,115,10,(int)(-110*arrayOfData[i]),QBrush(QColor(0,0,0)));
    }
  }
}
