#ifndef THENEURON      // falls Neuron irgendwie zweimal inkludiert wird
#define THENEURON
 
#define RANDSKALIERUNG 0.1
#include <iostream>

class Neuron;

//ostream& operator << (ostream &, const Neuron &);
//istream& operator >> (istream &, Neuron &);

class Neuron {
  friend ostream& operator<< (ostream &ostr, const Neuron &);
  friend istream& operator>> (istream &istr, Neuron &);

 protected:
  // Variablen, die in die .NTZ Dateien gespeichert werden
  // (auch in dieser Reihenfolge)
  int inputDim;
  double *gewichte;
  double schwelle;

  // andere Variablen
  double *deltaGewichte;
  double deltaSchwelle; 

 public:
  Neuron(int);
  Neuron(int, double *, double);
  ~Neuron(void);
  Neuron(const Neuron &);      // falls Copy gebraucht wird (tief)
  double propagate(double *);  // Propagate ohne Transferfunktion!
  void doDeltas(void);    
  static double doRand(void);

  // Getter/Setter
  void updateDeltas(double *, double);
  double getSchwelle(void){ return schwelle; }
  int getInputDim(void){ return inputDim; }
  double *getGewichte(void){ return gewichte; }
};
  
#endif
