#include <fstream>
#include <iostream>
#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <stdlib.h>

#include "SetFile.h"

using namespace std;


SetFile :: SetFile(void) : dim(0), FileName(""), ptr(1){}

SetFile :: SetFile(string setfilename) : dim(0), FileName(""), ptr(1)
{ 
  char * sfn = (char *)setfilename.c_str();
  
  // um Dimension in die 1. Zeile zu schreiben
  ofstream datei_out;
  
  // da sonst die *.set File nicht fr alle lesbar
  umask(000);

  // *.set File wird angelegt
  if ( creat(sfn, 0664) == -1 )
    cerr << "Fehler beim Erstellen der Datei " << setfilename << endl;
    
  // die Standardeinstellung im Fachbereichsnetz wiederherstellen
  umask(066);

  // hier ist jetzt sichergestellt, dass die Datei existiert
  // und die noetigen Zugriffsrechte hat
  datei_out.open(sfn, ios::out);

  // Anzahl der Datensatze = 0 reinschreiben
  datei_out << 0 << endl;

  datei_out.close();
}

SetFile :: ~SetFile(void){}

void SetFile :: setFileName(string setfilename)
{
  // um Daten, wie Dimension zu bekommen, falls Datei existiert
  ifstream datei_in;

  string line;

  int err;
  
  FileName=setfilename;

  char * sfn = (char *)setfilename.c_str();

  ptr = 1;

  // ffnen der Datei, es ist nicht sichergestellt, dass sie existiert
  datei_in.open(sfn, ios::in|ios::nocreate);

  // die Datei existiert noch nicht, also anlegen
  if ( !datei_in ){

    dim =0;

    // um Dimension in die 1. Zeile zu schreiben
    ofstream datei_out;
  
    // da sonst die *.set File nicht fr alle lesbar
    umask(000);
    
    // *.set File wird angelegt
    if ( creat(sfn, 0664) == -1 )
      cerr << "Fehler beim Erstellen der Datei " << setfilename << endl;
    
    // die Standardeinstellung im Fachbereichsnetz wiederherstellen
    umask(066);
    
    // hier ist jetzt sichergestellt, dass die Datei existiert
    // und die noetigen Zugriffsrechte hat
    datei_out.open(sfn, ios::out);
    
    // Anzahl der Datensatze = 0 reinschreiben
    datei_out << 0 << endl;
    
    datei_out.close();
    
  }else{ // *.set File existiert
    
    getline(datei_in,line);

    if ( (err=string2int((char *)line.c_str(),dim))==-1 ){

      FileName = "";
      
      cerr << "Die Datei " << setfilename << " enthaelt keine gueltige 1. Zeile" << endl;
      
      // etwas anderes vielleicht ???
      exit(1);
    
    }
  }

}

int SetFile :: add(int zeile, string aufilename)
{
  // line ist die jeweils eingelesene Zeile
  // in new_file wird der neue String zusammengebastelt
  // wie er spter komplett in die Datei geschrieben wird
  string new_file, line;

  // der lesende Stream zur Datei
  ifstream datei_in;
  
  // der schreibende Stream zur Datei
  ofstream datei_out;

  if ((zeile<=0) || (zeile>(dim+1))){

    cerr << "Ungueltige Zeilenangabe fuer Datei " << FileName << endl;

    return -1;

  }

  // ffnen der Datei, es ist nicht sichergestellt, dass sie existiert
  datei_in.open((char *)FileName.c_str(), ios::in|ios::nocreate);

  if ( !datei_in ){

    cerr << "Fehler beim Lesen der Datei " << FileName << endl;
    
    return -1;

  }

  // es wird davon ausgegangen, dass es sich um eine gueltige
  // *.set File handelt(sprich, dass in der 1. Zeile ein Dim.angabe steht)

  // die 1. Zeile mit der alten Dimension ueberspringen
  getline(datei_in,line);

  if (zeile==1) new_file += (aufilename + "\n");

  // Zeilen durchgehen und an String new_file anhngen
  for (int i = 1; i <= dim; i++){
    
    getline(datei_in,line);
    
    new_file += line;
    
    if (line != "") new_file += "\n";
    
    // Zeile einfgen
    if (i==(zeile-1)) new_file += (aufilename + "\n");
    
  }

  datei_in.close();

  dim++;
  
  datei_out.open((char *)FileName.c_str(), ios::out);

  if ( !datei_out ){

    cerr << "Fehler beim Schreiben der Datei " << FileName << endl;
    
    return -1;

  }
  
  // schreiben in die Datei
  datei_out << dim << endl << new_file;

  datei_out.close();

  return zeile;
}

int SetFile :: add(string aufilename)
{
  string tmp;

  int ret;

  reset();

  do{

    tmp = getPath();

  }

  while( (tmp < aufilename) && ((getPtr()-1) <= getDim()) );

  // um doppelte Eintraege zu vermeiden
  if (tmp != aufilename)
    ret = add(getPtr()-1,aufilename);
  else
    ret = 0;

  reset();

  return ret;
}

int SetFile :: rem(int zeile)
{
  // line ist die jeweils eingelesene Zeile
  // in new_file wird der neue String zusammengebastelt
  // wie er spter komplett in die Datei geschrieben wird
  string new_file, line;

  // der lesende Stream zur Datei
  ifstream datei_in;
  
  // der schreibende Stream zur Datei
  ofstream datei_out;

  if ((zeile<=0) || (zeile>(dim+1))){

    cerr << "Ungueltige Zeilenangabe fuer Datei " << FileName << endl;

    return -1;

  }

  // ffnen der Datei, es ist nicht sichergestellt, dass sie existiert
  datei_in.open((char *)FileName.c_str(), ios::in|ios::nocreate);
  
  if ( !datei_in ){

    cerr << "Fehler beim Lesen der Datei " << FileName << endl;
    
    return -1;

  }

  // es wird davon ausgegangen, dass es sich um eine gueltige
  // *.set File handelt(sprich, dass in der 1. Zeile eine Dim.angabe steht)

  // die 1. Zeile mit der alten Dimension ueberspringen
  getline(datei_in,line);

  // Zeilen durchgehen und an String new_file anhngen
  for (int i = 1; i <= dim; i++){
    
    getline(datei_in,line);
    
    // lschen durch weglassen in Kopie
    if (i!=zeile) new_file += line;
    
    if( (i!=zeile) && (line!="") ) new_file += "\n";
    
  }
  
  datei_in.close();

  dim--;
  
  datei_out.open((char *)FileName.c_str(), ios::out);

  if ( !datei_out ){

    cerr << "Fehler beim Schreiben der Datei " << FileName << endl;
    
    return -1;

  }
  
  // schreiben in die Datei
  datei_out << dim << endl << new_file;

  datei_out.close();

  return zeile;
}

int SetFile :: rem(string aufilename)
{
  string tmp;

  int ret;

  reset();

  do{

    tmp = getPath();

  }

  while( (tmp < aufilename) && ((getPtr()-1) <= getDim()) );

  // der eigentliche Pfad wird geloescht
  if ((getPath(getPtr()-1)) == aufilename)
    ret = rem(getPtr()-1);
  else
    ret =-1;

  reset();

  return ret;
}

string SetFile :: getPath(int zeile)
{
  // der lesende Stream zur Datei
  ifstream datei_in;

  // die aktuelle Zeile aus der *.set Datei
  string line;

  if ((zeile<0) || (zeile>(dim+1))){

    cerr << "Ungueltige Zeilenangabe fuer Datei " << FileName << endl;

    return "";

  }

  // ffnen der Datei, es ist nicht sichergestellt, dass sie existiert
  datei_in.open((char *)FileName.c_str(), ios::in|ios::nocreate);
  
  if ( !datei_in ){

    cerr << "Fehler beim Lesen der Datei " << FileName << endl;
    
    return "";

  }

  // es wird davon ausgegangen, dass es sich um eine gueltige
  // *.set File handelt(sprich, dass in der 1. Zeile eine Dim.angabe steht)

  // Zeilen durchgehen und an String new_file anhngen
  for (int i = 0; i <= zeile; i++)
    getline(datei_in,line);

  datei_in.close();

  return line;
}

string SetFile :: getPath()
{
  string ret = getPath(ptr);

  ptr++;

  return ret;
}

int SetFile :: setPtr(int i)
{
  if ((i<0) || (i>(dim+1))){

    cerr << "Ungueltige Zeilenangabe fuer Datei " << FileName << endl;

    return -1;

  }
  
  ptr = i;

  return ptr;
}

int SetFile :: string2int(char* digit, int& result)
{

   for (result=0; (*digit >= '0') && (*digit <='9'); digit++)
      result = (result * 10) + (*digit - '0');

   // gucken, ob noch Nichtzahlen folgen
   if (*digit != 0) {
     result = 0;
     return -1;
   }
   
   return 0;
}
