#include "Statistik.h"
#include <iostream>
#include <math.h> 

ostream& operator<< (ostream &ostr, const Statistik &myStat){
  ostr << myStat.trainingsLaenge << endl;
  for (int i=0;i<myStat.trainingsLaenge;i++) {
    if(!isnan(myStat.trainingsFehler[i]))
      ostr << myStat.trainingsFehler[i] << " ";
    else {
      ostr << "0.0 ";
      //cerr << "NaN gefunden und getoetet.\n";
    }
  }
  ostr << endl;

  ostr << myStat.testLaenge << endl;
  for (int i=0;i<myStat.testLaenge;i++) {
    if(!isnan(myStat.testFehler[i]))
      ostr << myStat.testFehler[i] << " ";
    else {
      ostr << "0.0 ";
      //cerr << "NaN gefunden und getoetet.\n";
    }
  }
  ostr << endl;

  ostr << flush;
  return ostr;
}


istream& operator>> (istream &istr, Statistik &myStat){
  istr >> myStat.trainingsLaenge;
  myStat.maxTrainingsLaenge = myStat.trainingsLaenge+(DEFLAENGE/2);
  delete[] myStat.trainingsFehler;
  myStat.trainingsFehler = new double[myStat.maxTrainingsLaenge];
  for(int i=0;i<myStat.trainingsLaenge;i++)
    istr >> myStat.trainingsFehler[i];
  
  istr >> myStat.testLaenge;
  myStat.maxTestLaenge = myStat.testLaenge+(DEFLAENGE/2);
  delete[] myStat.testFehler;
  myStat.testFehler = new double[myStat.maxTestLaenge];
  for(int i=0;i<myStat.testLaenge;i++)
    istr >> myStat.testFehler[i];
  
  return istr;
}



Statistik::Statistik(void){
  trainingsFehler = new double[DEFLAENGE];
  testFehler = new double[DEFLAENGE];
  trainingsLaenge = 0;
  testLaenge = 0;
  maxTrainingsLaenge = DEFLAENGE;
  maxTestLaenge = DEFLAENGE;
}



Statistik::~Statistik(void){
  delete[] trainingsFehler;
  delete[] testFehler;
}



void Statistik::addTest(double in){
  if (testLaenge<maxTestLaenge) {
    testFehler[testLaenge] = in;
    testLaenge++;
  } else {
    double *temp = new double[maxTestLaenge+DEFLAENGE];
    for(int i=0;i<maxTestLaenge;i++)
      temp[i] = testFehler[i];
    temp[maxTestLaenge] = in;
    delete[] testFehler;
    testFehler = temp;
    maxTestLaenge += DEFLAENGE;
    testLaenge++;
  }
}



void Statistik::addTraining(double in){
  if (trainingsLaenge<maxTrainingsLaenge) {
    trainingsFehler[trainingsLaenge] = in;
    trainingsLaenge++;
  } else {
    double *temp = new double[maxTrainingsLaenge+DEFLAENGE];
    for(int i=0;i<maxTrainingsLaenge;i++)
      temp[i] = trainingsFehler[i];
    temp[maxTrainingsLaenge] = in;
    delete[] trainingsFehler;
    trainingsFehler = temp;
    maxTrainingsLaenge += DEFLAENGE;
    trainingsLaenge++;
  }
}
